/* drawsound -- interpret drawn lines using MYWAVETABLE, a simple
	mod of "lsystem4". This version uses DrawLines (smoother) -- BGG/2003
*/
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#define MAIN		/* So RTcmix globals will be right */
#include <globals.h>

#include "drawsound.h"
#include <iostream.h>


IMPLEMENT_APP(drawsound)

bool drawsound::OnInit()
{
	wxFrame *frame = new wxFrame((wxFrame*) NULL, -1, "drawsound",
		wxPoint(50, 50), wxSize(1000, 600),
		wxDEFAULT_FRAME_STYLE, "drawsound");
	frame->Show(TRUE);
	SetTopWindow(frame);

	wxButton *button1 = new wxButton(frame, BUTTON_HIT1, "play it",
		wxPoint(100, 550), wxSize(70, 20));

	wdc = new wxClientDC(frame);

	RTcmix *rrr = new RTcmix(44100.0, 2);
	sleep(1);
	rrr->cmd("load", 1, "./MYWAVETABLE/libMYWAVETABLE.so");
	rrr->cmd("makegen", 7, 1.0, 24.0, 1000.0, 0.0, 1.0, 1.0, 1.0);
	rrr->cmd("makegen", 5, 2.0, 10.0, 1000.0, 1.0);
	rrr->cmd("reset", 1, 44100.0);

	theTimer = new myTimer(wdc, rrr);

	return true;
}

void drawsound::OnButton1(wxCommandEvent& command)
{
	theTimer->setX(0);
	theTimer->Start(100, wxTIMER_CONTINUOUS);
}

void drawsound::OnMouse(wxMouseEvent& command)
{
// the mouse event-handler -- note that the ButtonDown sets the oldx,oldy
	int x,y;

	if (command.ButtonDown() == TRUE)
	{
		oldx = command.GetX();
		oldy = command.GetY();
	}

	if (command.Dragging() == TRUE)
	{
		x = command.GetX();
		y = command.GetY();

		wdc->SetPen(*wxRED_PEN);
		wdc->DrawLine(oldx,oldy, x,y);

		oldx = x;
		oldy = y;
	}
}

BEGIN_EVENT_TABLE(drawsound, wxApp)
	EVT_BUTTON(BUTTON_HIT1, drawsound::OnButton1)
	EVT_MOUSE_EVENTS(drawsound::OnMouse)
END_EVENT_TABLE()
